import { jsx } from "react/jsx-runtime";
import { Component } from "react";
import MouseMonitor from "./MouseMonitor.js";
class Popup extends Component {
  constructor() {
    super(...arguments);
    this.state = {
      mouseIn: false
    };
  }
  render() {
    const { onMouseOver, popupContent, onMouseOut } = this.props;
    return /* @__PURE__ */ jsx(
      "div",
      {
        onMouseOver: () => {
          this.setState({ mouseIn: true });
          onMouseOver(
            /* @__PURE__ */ jsx(
              MouseMonitor,
              {
                onMoveAway: () => {
                  if (this.state.mouseIn) {
                    return;
                  }
                  onMouseOut();
                },
                paddingX: 60,
                paddingY: 30,
                children: popupContent
              }
            )
          );
        },
        onMouseOut: () => {
          this.setState({ mouseIn: false });
        },
        children: this.props.children
      }
    );
  }
}
export {
  Popup,
  Popup as default
};
